﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Monnit;
using Monnit.Mine;

namespace SampleMineApplication
{
    public partial class MineSensor : Form
    {
        private Sensor _Sensor;

        public MineSensor(Sensor sensor)
        {
            InitializeComponent();

            _Sensor = sensor;
        }

        private void MineSensor_Load(object sender, EventArgs e)
        {
            if(_Sensor == null)
            {
                MessageBox.Show("Sensor is null");
                this.Close();
            }
            txtSensorID.Text = _Sensor.SensorID.ToString();
            txtSensorType.Text = (_Sensor.MonnitApplication).ToString();
            
            cbSendGeneral1.Checked = _Sensor.GeneralConfig1Dirty;
            txtReportInterval.Text = _Sensor.ReportInterval.ToString();
            //Convert LinkInterval to minutes
            int link = _Sensor.TransmitIntervalLink;
            if (link > 100)
                link = link - 100;
            else
                link = link * 60;
            txtLinkInterval.Text = link.ToString();
            txtReportInterval.Enabled = !_Sensor.GeneralConfig1Dirty;
            txtLinkInterval.Enabled = !_Sensor.GeneralConfig1Dirty;
            btnUpdateConfig1.Enabled = !_Sensor.GeneralConfig1Dirty;
            
            cbSendGeneral2.Checked = _Sensor.GeneralConfig2Dirty;
            txtRetryCount.Text = _Sensor.RetryCount.ToString();
            txtRecovery.Text = _Sensor.Recovery.ToString();
            txtRetryCount.Enabled = !_Sensor.GeneralConfig2Dirty;
            txtRecovery.Enabled = !_Sensor.GeneralConfig2Dirty;
            btnUpdateConfig2.Enabled = !_Sensor.GeneralConfig2Dirty;

        }

        private void btnUpdateConfig1_Click(object sender, EventArgs e)
        {
            double ReportInterval = 0;
            int TransmitIntervalLink = 0;
            
            try
            {
                if (!double.TryParse(txtReportInterval.Text, out ReportInterval))
                    throw new Exception("Invalid Report Interval");
                if (!Int32.TryParse(txtLinkInterval.Text, out TransmitIntervalLink))
                    throw new Exception("Invalid Interval Link");

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }
            _Sensor.UpdateReportInterval(ReportInterval);
            _Sensor.UpdateLinkInterval(TransmitIntervalLink);

            MineSensor_Load(this, null);
        }

        private void btnUpdateConfig2_Click(object sender, EventArgs e)
        {
            int RetryCount = 0;
            int Recovery = 0;
            
            try
            {
                if (!Int32.TryParse(txtRetryCount.Text, out RetryCount))
                    throw new Exception("Invalid Retry Count");
                if (!Int32.TryParse(txtRecovery.Text, out Recovery))
                    throw new Exception("Invalid Recovery");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }
            _Sensor.UpdateRetryCount(RetryCount); 
            _Sensor.UpdateRecoveryCount(Recovery);

            MineSensor_Load(this, null);
        }
    }
}
